/*
 * This file is a part of the mg project.
 * Copyright (C) 1998 Martin Gall
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
/*
 *
 */

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include "lay_arp.h"
#include "lay_ip.h"
#include "lay_ether.h"
#include "lay_data.h"
#include "typ_16.h"
#include "typ_8.h"
#include "typ_inaddr.h"
#include "typ_ethaddr.h"
#include "typ_mac.h"

VOID_FUNC		arpethip_set_sha(aei,mba_sha)
t_arpethip		*aei;	
t_ether_addr		*mba_sha;
{
  FBCOPY(mba_sha,&(aei->sha),sizeof (t_ether_addr));
}

VOID_FUNC		arpethip_get_sha(aei,mba_sha)
t_arpethip		*aei;
t_ether_addr		*mba_sha;
{
  FBCOPY(&(aei->sha),mba_sha,sizeof (t_ether_addr));
}

VOID_FUNC		arpethip_set_tha(aei,mba_tha)
t_arpethip		*aei;	
t_ether_addr		*mba_tha;
{
  FBCOPY(mba_tha,&(aei->tha),sizeof (t_ether_addr));
}

VOID_FUNC		arpethip_get_tha(aei,mba_tha)
t_arpethip		*aei;
t_ether_addr		*mba_tha;
{
  FBCOPY(&(aei->tha),mba_tha,sizeof (t_ether_addr));
}

VOID_FUNC		arpethip_set_tpa(aei,mba_tpa)
t_arpethip		*aei;	
t_in_addr		*mba_tpa;
{
  FBCOPY(mba_tpa,&(aei->tpa),sizeof (struct in_addr));
}

VOID_FUNC		arpethip_get_tpa(aei,mba_tpa)
t_arpethip		*aei;
t_in_addr		*mba_tpa;
{
  FBCOPY(&(aei->tpa),mba_tpa,sizeof (struct in_addr));
}

VOID_FUNC		arpethip_set_spa(aei,mba_spa)
t_arpethip		*aei;	
t_in_addr		*mba_spa;
{
  FBCOPY(mba_spa,&(aei->spa),sizeof (struct in_addr));
}

VOID_FUNC		arpethip_get_spa(aei,mba_spa)
t_arpethip		*aei;
t_in_addr		*mba_spa;
{
  FBCOPY(&(aei->spa),mba_spa,sizeof (struct in_addr));
}

t_field				arpethip_fields[] = 
{
  {"sha",	OFFSET(t_arpethip *,sha),typ_etheraddr_msg,		NULL},
  {"Sha",	OFFSET(t_arpethip *,sha),typ_mac_msg,			NULL},
  {"spa",	OFFSET(t_arpethip *,spa),typ_inaddr_msg,		NULL},
  {"Spa",	OFFSET(t_arpethip *,spa),typ_inaddr_resolved_msg,	NULL},
  {"tha",	OFFSET(t_arpethip *,tha),typ_etheraddr_msg,		NULL},
  {"Tha",	OFFSET(t_arpethip *,tha),typ_mac_msg,			NULL},
  {"tpa",	OFFSET(t_arpethip *,tpa),typ_inaddr_msg,		NULL},
  {"Tpa",	OFFSET(t_arpethip *,tpa),typ_inaddr_resolved_msg,	NULL},
  NULL_FIELD
};

char				*arpethip_itmpl = "\n\
<table _name=arpethip[%i%] width=100%%%% bgcolor=\"%%arpethipColor%%\">\n\
<tr>\n\
<td align=center width=100%%%%>\n\
<a href=\"set(arpethip[%i%].sha)\">%%arpethip[%i%].sha%%</a>\n\
<_tiny>\n\
<a href=\"set(arpethip[%i%].Sha)\">%%arpethip[%i%].Sha%%</a>\n\
</_tiny>\n\
</td>\n\
</tr>\n\
<tr>\n\
<td align=center width=100%%%%>\n\
<a href=\"set(arpethip[%i%].Spa)\">%%arpethip[%i%].Spa%%</a>\n\
(<a href=\"set(arpethip[%i%].spa)\">%%arpethip[%i%].spa%%</a>)\n\
</td>\n\
</tr>\n\
<tr>\n\
<td align=center width=100%%%%>\n\
<a href=\"set(arpethip[%i%].tha)\">%%arpethip[%i%].tha%%</a>\n\
<_tiny>\n\
<a href=\"set(arpethip[%i%].Tha)\">%%arpethip[%i%].Tha%%</a>\n\
</_tiny>\n\
</td>\n\
</tr>\n\
<tr>\n\
<td align=center width=100%%%%>\n\
<a href=\"set(arpethip[%i%].Tpa)\">%%arpethip[%i%].Tpa%%</a>\n\
(<a href=\"set(arpethip[%i%].tpa)\">%%arpethip[%i%].tpa%%</a>)\n\
</td>\n\
</tr>\n\
</table>\n\
";

t_status			lay_arpethip_msg(msg,arg1,arg2)
t_msg				msg;
VOID_PTR			arg1;
VOID_PTR			arg2;
{
  switch (msg)
    {
      LAY_CLASS_GENERIC;
      LAY_NAME_ID_GENERIC((VOID_PTR)&lay_arpethip_msg,"arpethip");
      LAY_GET_FIELD_GENERIC(arpethip_fields);
      LAY_SET_FIELD_GENERIC(arpethip_fields);
      LAY_GET_FIELDS_GENERIC(arpethip_fields);
      LAY_GET_FIELD_TYP_GENERIC(arpethip_fields);
      LAY_GET_ITMPL_GENERIC((VOID_PTR)&lay_arpethip_msg,arpethip_itmpl);
    case LAY_SUB:
      {
	LAY_SUB_ARGS(b,mp);

	(*mp) = lay_data_msg;
	return (0);
      }
    case LAY_OFF:
      {
	LAY_OFF_ARGS(b,off);
	
	(*off) = ARPETHIP_HLEN;
	return (0);
      }
    }
  return (-ERR_LAYER_NOLAYMETHOD);
}

t_assoc		arphrd_assocs[] = 
{
  {"ether",	(VOID_PTR)ARPHRD_ETHER},
  {"802",	(VOID_PTR)ARPHRD_802},
  NULL_ASSOC
};

t_assoc		arpop_assocs[] = 
{
  {"request",	(VOID_PTR)ARPOP_REQUEST},
  {"reply",	(VOID_PTR)ARPOP_REPLY},
  NULL_ASSOC
};

VOID_FUNC	arp_set_hrd(arp,hrd)
t_arp		*arp;
int		hrd;
{
  safe_htons(hrd,(&arp->hrd));
}

int		arp_get_hrd(arp)
t_arp		*arp;
{
  return (safe_ntohs(&(arp->hrd)));
}

VOID_FUNC	arp_set_pro(arp,pro)
t_arp		*arp;
int		pro;
{
  safe_htons(pro,&(arp->pro));
}

int		arp_get_pro(arp)
t_arp		*arp;
{
  return (safe_ntohs(&(arp->pro)));
}

VOID_FUNC	arp_set_hln(arp,hln)
t_arp		*arp;
int		hln;
{
  arp->hln = hln;
}

int		arp_get_hln(arp)
t_arp		*arp;
{
  return (arp->hln);
}

VOID_FUNC	arp_set_pln(arp,pln)
t_arp		*arp;
int		pln;
{
  arp->pln = pln;
}

int		arp_get_pln(arp)
t_arp		*arp;
{
  return (arp->pln);
}

VOID_FUNC	arp_set_op(arp,op)
t_arp		*arp;
int		op;
{
  safe_htons(op,&(arp->op));
}

int		arp_get_op(arp)
t_arp		*arp;
{
  return (safe_ntohs(&(arp->op)));
}

t_status	arp_sub(buf,len,sub_mp)
char		*buf;
int		len;
t_msg_proc	*sub_mp;
{
  t_arp	*arp;

  LAYER_ARP_CHECK(arp,buf,len);
  if (arp_get_hrd(arp) == ARPHRD_ETHER &&
      arp_get_pro(arp) == ETHERTYPE_IP)
    {
      (*sub_mp) = &lay_arpethip_msg;
      return (0);
    }
  else
    {
      (*sub_mp) = &lay_data_msg;
      return (0);
    }
}

t_field				arp_fields[] = 
{
  {"hrd",	OFFSET(t_arp *,hrd),	typ_nu16_msg,		NULL},
  {"Hrd",	OFFSET(t_arp *,hrd),	typ_nu16assoc_msg,	arphrd_assocs},
  {"pro",	OFFSET(t_arp *,pro),	typ_nu16_msg,		NULL},
  {"Pro",	OFFSET(t_arp *,pro),	typ_nu16assoc_msg,   ethertype_assocs},
  {"hln",	OFFSET(t_arp *,hln),	typ_u8_msg,		NULL},
  {"pln",	OFFSET(t_arp *,pln),	typ_u8_msg,		NULL},
  {"op",	OFFSET(t_arp *,op),	typ_nu16_msg,		NULL},
  {"Op",	OFFSET(t_arp *,op),	typ_nu16assoc_msg,    arpop_assocs},
  NULL_FIELD
};

char				*arp_itmpl = "\n\
<table _name=arp[%i%] width=100%%%% bgcolor=\"%%arpColor%%\">\n\
<tr>\n\
<td align=center width=50%%%%>\n\
<a href=\"set(arp[%i%].Hrd)\">%%arp[%i%].Hrd%%</a>\n\
(<a href=\"set(arp[%i%].hrd)\">%%arp[%i%].hrd%%</a>)\n\
</td>\n\
<td align=center width=50%%%%>\n\
<a href=\"set(arp[%i%].Pro)\">%%arp[%i%].Pro%%</a>\n\
(<a href=\"set(arp[%i%].pro)\">%%arp[%i%].pro%%</a>)\n\
</td>\n\
</tr>\n\
<tr>\n\
<td align=center width=25%%%%>\n\
<a href=\"set(arp[%i%].hln)\">%%arp[%i%].hln%%</a>\n\
</td>\n\
<td align=center width=25%%%%>\n\
<a href=\"set(arp[%i%].pln)\">%%arp[%i%].pln%%</a>\n\
</td>\n\
<td align=center width=50%%%%>\n\
<a href=\"set(arp[%i%].Op)\">%%arp[%i%].Op%%</a>\n\
(<a href=\"set(arp[%i%].op)\">%%arp[%i%].op%%</a>)\n\
</td>\n\
</tr>\n\
</table>\n\
";

t_status			lay_arp_msg(msg,arg1,arg2)
t_msg				msg;
VOID_PTR			arg1;
VOID_PTR			arg2;
{
  switch (msg)
    {
      LAY_CLASS_GENERIC;
      LAY_NAME_ID_GENERIC((VOID_PTR)&lay_arp_msg,"arp");
      LAY_GET_FIELD_GENERIC(arp_fields);
      LAY_SET_FIELD_GENERIC(arp_fields);
      LAY_GET_FIELDS_GENERIC(arp_fields);
      LAY_GET_FIELD_TYP_GENERIC(arp_fields);
      LAY_GET_ITMPL_GENERIC((VOID_PTR)&lay_arp_msg,arp_itmpl);
    case LAY_OFF:
      {
	LAY_OFF_ARGS(b,off);
	
	(*off) = ARP_HLEN;
	return (0);
      }
    case LAY_SUB:
      {
	LAY_SUB_ARGS(b,mp);
	
	return (arp_sub(b->buf,b->len,mp));
      }
    }
  return (-ERR_LAYER_NOLAYMETHOD);
}
