/*
 * This file is a part of the mg project.
 * Copyright (C) 1998 Martin Gall
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
/*
 *
 */

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h> 
#include <arpa/tftp.h>
#include "lay_tftp.h"
#include "lay_ip.h"
#include "lay_ether.h"
#include "lay_data.h"
#include "typ_16.h"
#include "typ_8.h"
#include "typ_sz.h"

t_field				tftpmode_fields[] = 
{
  {"mode",	0,		typ_sz_msg,		NULL},
  NULL_FIELD
};

char				*tftpmode_itmpl = "\n\
<table _name=tftpmode[%i%] width=100%%%% bgcolor=\"%%tftpmodeColor%%\">\n\
<tr>\n\
<td align=center width=50%%%%>\n\
<a href=\"set(tftpmode[%i%].mode)\">%%tftpmode[%i%].mode%%</a>\n\
</td>\n\
</tr>\n\
</table>\n\
";

t_status			lay_tftpmode_msg(msg,arg1,arg2)
t_msg				msg;
VOID_PTR			arg1;
VOID_PTR			arg2;
{
  switch (msg)
    {
      LAY_CLASS_GENERIC;
      LAY_NAME_ID_GENERIC((VOID_PTR)&lay_tftpmode_msg,"tftpmode");
      LAY_GET_FIELD_GENERIC(tftpmode_fields);
      LAY_SET_FIELD_GENERIC(tftpmode_fields);
      LAY_GET_FIELDS_GENERIC(tftpmode_fields);
      LAY_GET_FIELD_TYP_GENERIC(tftpmode_fields);
      LAY_GET_ITMPL_GENERIC((VOID_PTR)&lay_tftpmode_msg,tftpmode_itmpl);
    case LAY_OFF:
      {
	LAY_OFF_ARGS(b,off);
	t_extract_data		ed;

	ed.b.buf = b->buf;
	ed.b.len = b->len;
	return (typ_msg(typ_sz_msg,
			TYP_OFF,
			&ed,
			off));
      }
    case LAY_SUB:
      {
	LAY_SUB_ARGS(b,mp);
	
	(*mp) = lay_data_msg;
	return (0);
      }
    }
  return (-ERR_LAYER_NOLAYMETHOD);
}

t_field				tftpfname_fields[] = 
{
  {"name",	0,		typ_sz_msg,		NULL},
  NULL_FIELD
};

char				*tftpfname_itmpl = "\n\
<table _name=tftpfname[%i%] width=100%%%% bgcolor=\"%%tftpfnameColor%%\">\n\
<tr>\n\
<td align=center width=50%%%%>\n\
<a href=\"set(tftpfname[%i%].name)\">%%tftpfname[%i%].name%%</a>\n\
</td>\n\
</tr>\n\
</table>\n\
";

t_status			lay_tftpfname_msg(msg,arg1,arg2)
t_msg				msg;
VOID_PTR			arg1;
VOID_PTR			arg2;
{
  switch (msg)
    {
      LAY_CLASS_GENERIC;
      LAY_NAME_ID_GENERIC((VOID_PTR)&lay_tftpfname_msg,"tftpfname");
      LAY_GET_FIELD_GENERIC(tftpfname_fields);
      LAY_SET_FIELD_GENERIC(tftpfname_fields);
      LAY_GET_FIELDS_GENERIC(tftpfname_fields);
      LAY_GET_FIELD_TYP_GENERIC(tftpfname_fields);
      LAY_GET_ITMPL_GENERIC((VOID_PTR)&lay_tftpfname_msg,tftpfname_itmpl);
    case LAY_OFF:
      {
	LAY_OFF_ARGS(b,off);
	t_extract_data		ed;

	ed.b.buf = b->buf;
	ed.b.len = b->len;
	return (typ_msg(typ_sz_msg,
			TYP_OFF,
			&ed,
			off));
      }
    case LAY_SUB:
      {
	LAY_SUB_ARGS(b,mp);
	
	(*mp) = lay_tftpmode_msg;
	return (0);
      }
    }
  return (-ERR_LAYER_NOLAYMETHOD);
}

t_assoc			tftpen_assocs[] =
{
  {"undef",		(VOID_PTR)EUNDEF},
  {"notfound",		(VOID_PTR)ENOTFOUND},
  {"access",		(VOID_PTR)EACCESS},
  {"nospace",		(VOID_PTR)ENOSPACE},
  {"badop",		(VOID_PTR)EBADOP},
  {"badid",		(VOID_PTR)EBADID},
  {"exists",		(VOID_PTR)EEXISTS},
  {"nouser",		(VOID_PTR)ENOUSER},
  {NULL,		NULL}
};

t_field				tftperror_fields[] = 
{
  {"en",	0,		typ_nu16_msg,		NULL},
  {"En",	0,		typ_nu16assoc_msg,	tftpen_assocs},
  {"msg",	2,		typ_sz_msg,		NULL},
  NULL_FIELD
};

char				*tftperror_itmpl = "\n\
<table _name=tftperror[%i%] width=100%%%% bgcolor=\"%%tftperrorColor%%\">\n\
<tr>\n\
<td align=center width=100%%%%>\n\
<a href=\"set(tftperror[%i%].En)\">%%tftperror[%i%].En%%</a>\n\
(<a href=\"set(tftperror[%i%].en)\">%%tftperror[%i%].en%%</a>)\n\
</td>\n\
</tr>\n\
<tr>\n\
<td align=center width=100%%%%>\n\
<a href=\"set(tftperror[%i%].msg)\">%%tftperror[%i%].msg%%</a>\n\
</td>\n\
</tr>\n\
</table>\n\
";

t_status			lay_tftperror_msg(msg,arg1,arg2)
t_msg				msg;
VOID_PTR			arg1;
VOID_PTR			arg2;
{
  t_status			status;

  switch (msg)
    {
      LAY_CLASS_GENERIC;
      LAY_NAME_ID_GENERIC((VOID_PTR)&lay_tftperror_msg,"tftperror");
      LAY_GET_FIELD_GENERIC(tftperror_fields);
      LAY_SET_FIELD_GENERIC(tftperror_fields);
      LAY_GET_FIELDS_GENERIC(tftperror_fields);
      LAY_GET_FIELD_TYP_GENERIC(tftperror_fields);
      LAY_GET_ITMPL_GENERIC((VOID_PTR)&lay_tftperror_msg,tftperror_itmpl);
    case LAY_OFF:
      {
	LAY_OFF_ARGS(b,off);
	t_off			msgoff;
	t_extract_data		ed;

	if (b->len < 2)
	  return (-ERR_LAYER_TRUNC);
	ed.b.buf = b->buf + 2;
	ed.b.len = b->len - 2;
	if ((status = typ_msg(typ_sz_msg,
			      TYP_OFF,
			      &ed,
			      &msgoff)) < 0)
	  return (status);
	(*off) = msgoff + 2;
	return (0);
      }
    case LAY_SUB:
      {
	LAY_SUB_ARGS(b,mp);
	
	(*mp) = lay_data_msg;
	return (0);
      }
    }
  return (-ERR_LAYER_NOLAYMETHOD);
}

t_field				tftpbn_fields[] = 
{
  {"bn",	0,		typ_nu16_msg,		NULL},
  NULL_FIELD
};

char				*tftpbn_itmpl = "\n\
<table _name=tftpbn[%i%] width=100%%%% bgcolor=\"%%tftpbnColor%%\">\n\
<tr>\n\
<td align=center width=100%%%%>\n\
<a href=\"set(tftpbn[%i%].bn)\">%%tftpbn[%i%].bn%%</a>\n\
</td>\n\
</tr>\n\
</table>\n\
";

t_status			lay_tftpbn_msg(msg,arg1,arg2)
t_msg				msg;
VOID_PTR			arg1;
VOID_PTR			arg2;
{
  switch (msg)
    {
      LAY_CLASS_GENERIC;
      LAY_NAME_ID_GENERIC((VOID_PTR)&lay_tftpbn_msg,"tftpbn");
      LAY_GET_FIELD_GENERIC(tftpbn_fields);
      LAY_SET_FIELD_GENERIC(tftpbn_fields);
      LAY_GET_FIELDS_GENERIC(tftpbn_fields);
      LAY_GET_FIELD_TYP_GENERIC(tftpbn_fields);
      LAY_GET_ITMPL_GENERIC((VOID_PTR)&lay_tftpbn_msg,tftpbn_itmpl);
    case LAY_OFF:
      {
	LAY_OFF_ARGS(b,off);
	
	(*off) = 2;
	return (0);
      }
    case LAY_SUB:
      {
	LAY_SUB_ARGS(b,mp);
	
	(*mp) = lay_data_msg;
	return (0);
      }
    }
  return (-ERR_LAYER_NOLAYMETHOD);
}

t_assoc		tftpopcode_assocs[] = 
{
  {"rrq",	(VOID_PTR)TFTPOP_RRQ},
  {"wrq",	(VOID_PTR)TFTPOP_WRQ},
  {"data",	(VOID_PTR)TFTPOP_DATA},
  {"ack",	(VOID_PTR)TFTPOP_ACK},
  {"error",	(VOID_PTR)TFTPOP_ERROR},
  {NULL,	0},
};

int		tftp_get_opcode(tftp)
t_tftp		*tftp;
{
  return (safe_ntohs(&tftp->opcode));
}

t_status	tftp_sub(buf,len,sub_mp)
char		*buf;
int		len;
t_msg_proc	*sub_mp;
{
  t_tftp	*tftp;

  LAYER_TFTP_CHECK(tftp,buf,len);
  switch (tftp_get_opcode(tftp))
    {
    case TFTPOP_RRQ:
    case TFTPOP_WRQ:
      (*sub_mp) = lay_tftpfname_msg;
      return (0);
    case TFTPOP_DATA:
    case TFTPOP_ACK:
      (*sub_mp) = lay_tftpbn_msg;
      return (0);
    case TFTPOP_ERROR:
      (*sub_mp) = lay_tftperror_msg;
      return (0);
    }
  (*sub_mp) = lay_data_msg;
  return (0);
}

t_field				tftp_fields[] = 
{
  {"opcode",	0,		typ_nu16_msg,		NULL},
  {"Opcode",	0,		typ_nu16assoc_msg,	tftpopcode_assocs},
  NULL_FIELD
};

char				*tftp_itmpl = "\n\
<table _name=tftp[%i%] width=100%%%% bgcolor=\"%%tftpColor%%\">\n\
<tr>\n\
<td align=center width=100%%%%>\n\
<a href=\"set(tftp[%i%].Opcode)\">%%tftp[%i%].Opcode%%</a>\n\
(<a href=\"set(tftp[%i%].opcode)\">%%tftp[%i%].opcode%%</a>)\n\
</td>\n\
</tr>\n\
</table>\n\
";

t_status			lay_tftp_msg(msg,arg1,arg2)
t_msg				msg;
VOID_PTR			arg1;
VOID_PTR			arg2;
{
  switch (msg)
    {
      LAY_CLASS_GENERIC;
      LAY_NAME_ID_GENERIC((VOID_PTR)&lay_tftp_msg,"tftp");
      LAY_GET_FIELD_GENERIC(tftp_fields);
      LAY_SET_FIELD_GENERIC(tftp_fields);
      LAY_GET_FIELDS_GENERIC(tftp_fields);
      LAY_GET_FIELD_TYP_GENERIC(tftp_fields);
      LAY_GET_ITMPL_GENERIC((VOID_PTR)&lay_tftp_msg,tftp_itmpl);
    case LAY_OFF:
      {
	LAY_OFF_ARGS(b,off);
	
	(*off) = 2;
	return (0);
      }
    case LAY_SUB:
      {
	LAY_SUB_ARGS(b,mp);
	
	return (tftp_sub(b->buf,b->len,mp));
      }
    }
  return (-ERR_LAYER_NOLAYMETHOD);
}
