/*
 * This file is a part of the mg project.
 * Copyright (C) 1998 Martin Gall
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
/*
 *
 */

#include "layer_err.h"

char		*err_layer_list[] = 
{
  "Error 0",					/* 0 */
  "Bad address",				/* 1 */
  "Bad class",					/* 2 */
  "Bad format",					/* 3 */
  "Bad header",					/* 4 */
  "Bad length",					/* 5 */
  "Bad match, e.g option length != from header",/* 6 */
  "Bad string-zero",				/* 7 */
  "Bad ASCII vector",				/* 8 */
  "Can't handle, e.g compressed data",		/* 9 */
  "Channel is in use",				/* 10 */
  "Netmask contains holes",			/* 11 */
  "Invalid argument",				/* 12 */
  "Malformed",					/* 13 */
  "Need more arguments",			/* 14 */
  "Not implemented",				/* 15 */
  "No choice",					/* 16 */
  "No entry",					/* 17 */
  "No \"lay\" method",				/* 18 */
  "Open error",					/* 19 */
  "Read error",					/* 20 */
  "Too big",					/* 21 */
  "Truncated",					/* 22 */
  "Unresolvable",				/* 23 */
  "Zero length or exact match",			/* 24 */
  "No such field",				/* 25 */
  "Write error",				/* 26 */
  "Syscall error",				/* 27 */
  "Loop, e.g zero length offset",		/* 28 */
  "Not enough room",				/* 29 */
  "No \"typ\" method",				/* 30 */
  "Bad family",					/* 31 */
};

t_status	err_layer_init(VOID_DECL)
{
  t_status	status;
  int		i;

  assert(err_id);
  i = 0;
  while (i < ARRAY_COUNT(err_layer_list))
    {
      if ((status = id_add(err_id,
			   (VOID_PTR)(ERR_LAYER_START + i),
			   err_layer_list[i])) < 0)
	return (status);
      i++;
    }
  return (0);
}	
