/*
 * This file is a part of the mg project.
 * Copyright (C) 1998 Martin Gall
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
/*
 *
 */

#include "layer.h"
#include "typ_msg.h"
#include "typ_boolean.h"

/* is a t_msg_proc.
   Manages boolean. It is not intended to use in a network 
   stream but it is used by configuration files. */
t_status		typ_boolean_msg(msg,arg1,arg2)
t_msg			msg;
VOID_PTR		arg1;
VOID_PTR		arg2;
{
  switch (msg)
    {
      TYP_CLASS_GENERIC;
      TYP_NAME_GENERIC("boolean");
    case TYP_EXTRACT:
      {
	TYP_EXTRACT_ARGS(ed,bs);
	t_boolean	boolean;

	if (ed->b.len < sizeof (boolean))
	  return (-ERR_LAYER_TRUNC);
	FBCOPY(ed->b.buf,&boolean,sizeof (t_boolean));
	if (boolean)
	  return (str_cat_str(bs->str,
			      bs->max_len,
			      "true"));
	else
	  return (str_cat_str(bs->str,
			      bs->max_len,
			      "false"));
      }
    case TYP_INSERT:
      {
	TYP_INSERT_ARGS(ed,str);
	t_boolean	boolean;
	t_status	status;	

	if (ed->b.len < sizeof (boolean))
	  return (-ERR_LAYER_TRUNC);
	if ((status = atobooleanstrict(str,&boolean)) < 0)
	  return (status);
	FBCOPY(&boolean,ed->b.buf,sizeof (t_boolean));
	return (0);
      }
    }
  return (-ERR_LAYER_NOTYPMETHOD);
}	
