/*
 *
 */

#ifndef LIP_H
#define LIP_H	1

#include <pcap.h>
#include "a.h"
#include "layer.h"
#include "pkt.h"
#include "lipfcache.h"
#include "liperr.h"

#ifdef DEBUG_MALLOC
# include "gdm.h"
# define LIP_ALLOC_ALGORITHM	gdm_alloc_algorithm
# define LIP_ALLOC_PROC		gdm_alloc
# define LIP_REALLOC_PROC	gdm_realloc
# define LIP_FREE_PROC		gdm_free
#else
# define LIP_ALLOC_ALGORITHM	alloc_algorithm_factor2
# define LIP_ALLOC_PROC		alloc_malloc
# define LIP_REALLOC_PROC	realloc_realloc
# define LIP_FREE_PROC		free_free
#endif

#define LIP_VEC_NEW(VecBase,StatusPtr)	vec_new((VecBase),\
					FALSE,\
					LIP_ALLOC_ALGORITHM,\
					LIP_ALLOC_PROC,\
					LIP_REALLOC_PROC,\
					LIP_FREE_PROC,\
					"ns",\
					(StatusPtr))

#define LIP_DICT_NEW(HashBase,VecBase,StatusPtr)	dict_new((HashBase),\
					 (VecBase),\
					 dict_hash_code_public,\
					 LIP_ALLOC_ALGORITHM,\
					 LIP_ALLOC_PROC,\
					 LIP_REALLOC_PROC,\
					 LIP_FREE_PROC,\
					 "ns",\
					 (StatusPtr))

struct s_global_config;

typedef struct			s_rule
{
  char				*name;
  char				*filter;
  struct bpf_program		bp;
  t_vec				*cmds;
  t_vec				*compiled_cmds;
  int				maxfails;
  int				count;
  int				fails;
  t_boolean			cont;
  t_boolean			cont_is_defined;
  int				maxkeep;
  struct s_global_config	*gc;
} t_rule;

typedef struct			s_global_config
{
  t_dict			*vars;
  pcap_t			*pcap;
  t_rule			*default_rule;
  t_vec				*rules;
  t_vec				*prefixes;
} t_global_config;

#include "lipcf.h"

#endif

