/*
 *
 */

#ifndef LIPCF_H
#define LIPCF_H	1

#include "lip.h"

#define RULES_STR		"rules"
#define DEFAULT_STR		"default"
#define PREFIXES_STR		"prefixes"
#define DATABASES_STR		"databases"
#define MATCHLISTS_STR		"matchlists"
#define FILTER_STR		".filter"
#define ACTION_STR		".action"
#define MAXFAILS_STR		".maxfails"
#define CONT_STR		".cont"
#define MAXKEEP_STR		".maxkeep"
#define EXP_STR			".exp"

#define MAXFAILS		256
#define MAXKEEP			256

typedef t_status	(*t_cmd_proc) P((t_vec *args,
					 t_pkt *pkt,
					 pcap_t *pcap,
					 t_rule *rule,
					 VOID_PTR data));

typedef struct		s_compiled_cmd
{
  t_cmd_proc		cmd_proc;
  VOID_PTR		data;
} t_compiled_cmd;

typedef t_status	(*t_cmd_init_proc) P((t_vec *args,
					      t_compiled_cmd *cc));
					      
/* PROTO lipcf.c */
/* lipcf.c */
t_dict *open_cf P((void));
t_vec *get_rules_names P((t_dict *vars));
t_vec *get_prefixes_names P((t_dict *vars));
t_vec *get_databases_names P((t_dict *vars));
t_vec *get_matchlists_names P((t_dict *vars));
t_vec *get_cmds P((char *str));
t_vec *compile_cmds P((t_vec *cmds));
t_rule *compile_rule P((pcap_t *pcap, t_dict *vars, char *name));
void show_rules P((t_vec *rules));
t_rule *rule_get_from_name P((t_vec *rules, char *name));
t_status init_things_for_cmds P((void));
void rule_destroy P((t_rule *rule));
void delete_rules P((t_vec *rules));
#endif
