/*
 *
 */

#include <fcntl.h>
#include "lip.h"

extern t_file_cache	file_cache_rplus;

FILE			*count_file_initialize(fname,status)
char			*fname;
t_status		*status;
{
  FILE			*f;
  t_boolean		initialize;
  
  initialize = FALSE;
retry:
  if ((f = file_cache_open(&file_cache_rplus,
			   fname,
			   status)) == NULL)
    {
      int		fd;

      if (initialize || *status != -ERR_LIP_OPEN)
	{
	  err_print(-(*status),"opening %s",fname);
	  return (NULL);
	}
      if ((fd = open(fname,O_RDWR|O_CREAT,0644)) < 0)
	{
	  err_print((*status) = ERR_LIP_OPEN,"creating %s",fname);
	  return (NULL);
	}
      close(fd);
      initialize = TRUE;
      goto retry;
    }
  if (initialize)
    {
      if (fprintf(f,"0 0 0\n") < 0)
	{
	  (*status) = -1;
	  return (NULL);
	}
      fflush(f);
    }
  return (f);
}

t_status		cmd_count(args,pkt,pcap,rule,data)
t_vec			*args;
t_pkt			*pkt;
pcap_t			*pcap;
t_rule			*rule;
VOID_PTR		data;
{
  t_status		status;
  FILE			*f;
  int			count;
  int			total_caplen;
  int			total_len;
  char			fname[MAXPATHLEN + 1];
  
  fname[0] = 0;
  if ((status = pkt_format_simple_permissive(pkt,
					     VEC_AT(args,1),
					     rule->gc->prefixes,
					     NULL,
					     fname,
					     sizeof (fname))) < 0)
    return (status);
  if ((f = file_cache_open(&file_cache_rplus,
			   fname,
			   &status)) == NULL)
    if ((f = count_file_initialize(fname,&status)) == NULL)
      return (status);
  rewind(f);
  if (fscanf(f,"%d %d %d",&count,&total_caplen,&total_len) != 3)
    return (-ERR_LIP_BADFMT);
  count++;
  total_caplen += pkt->len;
  total_len += pkt->netlen;
  rewind(f);
  if (fprintf(f,"%d %d %d\n",count,total_caplen,total_len) < 0)
    return (-ERR_LIP_WRITE);
  fflush(f);
  return (0);
}

t_status		cmd_count_init(args,cc)
t_vec			*args;
t_compiled_cmd		*cc;
{
  t_status		status;
  
  if (VEC_COUNT(args) != 2)
    {
      err_print(ERR_LIP_NEEDMORE,"syntax: count format_file");
      return (-1);
    }
  cc->cmd_proc = cmd_count;
  return (0);
}
