/*
 *
 */

#include "lip.h"
#include "lipexec.h"

int		exec_vec_from(pkt,prefixes,vec,frompos)
t_pkt		*pkt;
t_vec		*prefixes;
t_vec		*vec;
int		frompos;
{
  int		status;
  pid_t		pid;
  int		w;
  char		**argv;
  size_t	size;
  int		i;
  int		j;
  char		arg[STR_BUFSIZ];

  size = (VEC_COUNT(vec)  - frompos + 1) * sizeof (char *);
  if ((argv = LIP_ALLOC_PROC(size,
			    "lip",
			    "argv",
			    &status)) == NULL)
    return (status);
  i = 0;
  VEC_FOR_FROM(vec,frompos,char *str)
    {
      arg[0] = 0;
      if ((status = pkt_format_simple_permissive(pkt,
						 str,
						 prefixes,
						 NULL,
						 arg,
						 sizeof (arg))) < 0)
	return (status);
      if ((argv[i++] = strdup_alloc(arg,
				    LIP_ALLOC_PROC,
				    "lip",
				    "argv[i]",
				    &status)) == NULL)
	return (status);
    }
  VEC_ENDFOR;
  argv[i] = NULL;
  if ((pid = fork()) == 0)
    {
      execvp(argv[0],argv);
      err_print(ERR_LIP_SYSCALL,"can't execvp %s",argv[0]);
      exit(1);
    }
#ifdef NOTDEF
  signal(SIGINT,SIG_IGN);
  signal(SIGQUIT,SIG_IGN);
#endif
  while ((w = wait(&status)) != pid && w != -1)
    ;
  if (w == -1)
    status = -1;
#ifdef NOTDEF
  signal(SIGINT,SIG_DFL);
  signal(SIGQUIT,SIG_DFL);
#endif
  j = 0;
  while (j < i)
    {
      LIP_FREE_PROC(argv[j],
		   "lip",
		   "argv[j]");
      j++;
    } 
  LIP_FREE_PROC(argv,
	       "lip",
	       "argv");
  return (status);
}

t_status		cmd_exec(args,pkt,pcap,rule,data)
t_vec			*args;
t_pkt			*pkt;
pcap_t			*pcap;
t_rule			*rule;
VOID_PTR		data;
{
  t_status		status;

  return (exec_vec_from(pkt,rule->gc->prefixes,args,1));
}

t_status		cmd_exec_init(args,cc)
t_vec			*args;
t_compiled_cmd		*cc;
{
  t_status		status;

  if (VEC_COUNT(args) < 2)
    {
      err_print(ERR_LIP_NEEDMORE,
		"syntax: exec format_arg0 format_arg1 ... format_argn");
      return (-1);
    }
  cc->cmd_proc = cmd_exec;
  return (0);
}
