/*
 *
 */

#include "lip.h"

t_dict			*keepdict = NULL;
int			nbcmdkeepcalls = 0;
int			nbkeptpkts = 0;

t_status		cmd_keep(args,pkt,pcap,rule,data)
t_vec			*args;
t_pkt			*pkt;
pcap_t			*pcap;
t_rule			*rule;
VOID_PTR		data;	
{
  t_status		status;
  char			key[STR_BUFSIZ];
  t_pkt			*npkt;
  FILE			*f;
  t_hash_elt		*he;
  t_vec			*vec;
  
  nbcmdkeepcalls++;
  key[0] = 0;
  if ((status = pkt_format_simple_permissive(pkt,
					     VEC_AT(args,1),
					     rule->gc->prefixes,
					     NULL,
					     key,
					     sizeof (key))) < 0)
    return (status);
  if (he = dict_get(keepdict,key))
    vec = (t_vec *)(he->value);
  else
    {
      if ((vec = LIP_VEC_NEW(VEC_BASE,
			    &status)) == NULL)
	return (status);
      if ((status = dict_add(keepdict,key,vec)) < 0)
	return (status);
    }
  if ((npkt = pkt_dup(pkt,LIP_ALLOC_PROC,LIP_FREE_PROC,&status)) == NULL)
    return (status);
  if (VEC_COUNT(vec) < rule->maxkeep)
    {
      if ((status = vec_add(vec,npkt)) < 0)
	return (status);
    }
  else
    return (-ERR_LIP_TOOMUCHDATA);
  nbkeptpkts++;
  return (0);
}

t_status		cmd_keep_init(args,cc)
t_vec			*args;
t_compiled_cmd		*cc;
{
  if (VEC_COUNT(args) != 2)
    {
      err_print(ERR_LIP_TOOMANY,"syntax: keep format_key");
      return (-1);
    }
  cc->cmd_proc = cmd_keep;
  return (0);
}

VOID_FUNC		cmd_keep_info(VOID_DECL)
{
  fprintf(stderr,"cmd_keep was called %d time(s)\n",nbcmdkeepcalls);
  fprintf(stderr,"keepdict %d elt(s)\n",dict_count(keepdict));
  fprintf(stderr,"kept %d pkt(s)\n",nbkeptpkts);
}

t_status		free_vec_of_pkts(he,unused)
t_hash_elt		*he;
VOID_PTR		unused;
{
  t_vec			*vec;

  vec = (t_vec *)(he->value);
  VEC_FOR(vec,t_pkt *pkt)
    {
      LIP_FREE_PROC(pkt->buf,
		   "lip",
		   "pkt->buf");
      LIP_FREE_PROC(pkt,
		   "lip",
		   "pkt");
    }
  VEC_ENDFOR;
  vec_delete(vec);
  return (0);
}

VOID_FUNC		free_keepdict(VOID_DECL)
{
  dict_walk(keepdict,
	    (t_dict_walk_proc)free_vec_of_pkts,
	    NULL);
  dict_delete(keepdict);
}
