/*
 * This file is a part of the mg project.
 * Copyright (C) 1998 Martin Gall
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
/*
 *
 */

#ifndef XIPCF_H
#define XIPCF_H	1

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include "XmgFancy.h"
#include "a.h"
#include "lay_ether.h"
#include "lay_ip.h"
#include "typ_inaddr.h"
#include "typ_ethaddr.h"
#include "typ_8.h"
#include "typ_16.h"
#include "typ_32.h"
#include "typ_subnet.h"

typedef struct			s_xip_var
{
  char				*name;			/* must be static */
  t_off				offset;
  size_t			size;	
  t_msg_proc			mp;
  VOID_PTR			data;
} t_xip_var;

#define NULL_XIP_VAR		{NULL,0,0,NULL,NULL}

extern char			*tmpl_buf;
extern char			*html_buf;
extern char			*htmlize_buf;
extern t_u32			tmpl_bufsiz;
extern t_u32			html_bufsiz;
extern t_u32			htmlize_bufsiz;
extern struct in_addr		ghost_ip;
extern t_ether_addr		ghost_ether;
extern t_u16			ip_id;

typedef struct			s_xip_cf_box_entry
{
  char				*widget_name;
  char				*var;
} t_xip_cf_box_entry;

#define NULL_XIP_CF_BOX_ENTRY	{NULL,NULL}

typedef struct			s_xip_cf_box_group
{
  char				*widget_name;	/* must be static */
  char				*label;		/* must be static */
  t_xip_cf_box_entry		*entries;	/* must be static */
} t_xip_cf_box_group;

#define NULL_XIP_CF_BOX_GROUP	{NULL,NULL,NULL}

typedef t_status		(*t_xip_plugin_proc) P((VOID_DECL));

/* PROTO xipcf.c */
/* xipcf.c */
t_status typ_memoryzone_msg P((t_msg msg, void *arg1, void *arg2));
t_status get_extra_vars_from_xrm_walk P((t_hash_elt *he, XrmDatabase db));
t_status xip_extra_vars_get_from_xrm P((void));
void xip_extra_vars_destroy P((void));
t_xip_var *xip_var_get_from_name P((char *name));
t_status xip_var_set P((char *name, char *value));
t_status xip_var_get P((char *name, char *str, int max_len));
void xip_vars_destroy P((void));
t_status xip_vars_init P((void));
t_status xip_cf_save P((char *fname));
t_status xip_cf_load_walk P((t_hash_elt *he, void *unused));
t_status xip_cf_load P((char *fname));
void XipCfCancelCommand P((Widget w, Widget shell, void *cbs));
char *xip_var_get_static P((char *var));
void XipCfOkCommand P((Widget w, Widget shell, void *cbs));
void XipShowCfBox P((Widget parent));
#endif
